#include "stdafx.h"
#include <cstdlib>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <cmath>

typedef unsigned int Word;

using namespace std;

static void RestoreSprite(Word Config);
static void LoadSprites(FILE* fp);

static char Delimiters[] = " \t\n";        /* Token delimiters */
static char NumDelimiters[] = " ,\t\n";    /* Value delimiters */
static Word LineNum;               /* Line being executed from the script */
static char InputLine[256];        /* Input line from script */
static char *Commands[] = {
	"TYPE","LOAD","ENDIAN","LOADNEXT","LOADFIXED","LOADHANDLE"
};
#define CommandCount 6      /* Number of commands */

#define Swap2_2Bytes(val) val = ( (((val) >> 8) & 0x00FF) | (((val) << 8) & 0xFF00) )
#define Swap4Bytes(val) val = ( (((val) >> 24) & 0x000000FF) | (((val) >> 8) & 0x0000FF00) | (((val) <<  8) & 0x00FF0000) | (((val) << 24) & 0xFF000000) )
//#define SwapULong(val) val = ( (((val) >> 24) & 0x000000FF) | (((val) >> 8) & 0x0000FF00) | (((val) <<  8) & 0x00FF0000) | (((val) << 24) & 0xFF000000) )
//#define SwapULong(val) (val << 24 | (val << 8 & 0xFF0000) | (val >> 8 & 0xFF00) | val >> 24 & 0xFF)
#define Swap8Bytes(val) ( (((val) >> 56) & 0x00000000000000FF) | (((val) >> 40) & 0x000000000000FF00) | (((val) >> 24) & 0x0000000000FF0000) | (((val) >>  8) & 0x00000000FF000000) | (((val) <<  8) & 0x000000FF00000000) | (((val) << 24) & 0x0000FF0000000000) | (((val) << 40) & 0x00FF000000000000) | (((val) << 56) & 0xFF00000000000000) )
#define Swap2Bytes(val) ( (((val) >> 8) & 0x00FF) | (((val) << 8) & 0xFF00) )

int Count;


static void PrintError(char *Error)
{
	printf("# Error in Line %d, %s\n",LineNum,Error);
}





static void LoadSprites(FILE* fp)
{
	char *TextPtr;  /* Pointer to string token */
	Word i;         /* Index */

	while (fgets(InputLine,sizeof(InputLine),fp)) { /* Get a string */
		++LineNum;          /* Adjust the line # */
		TextPtr = strtok(InputLine,Delimiters); /* Get the first token */
		if (!TextPtr) {
			continue;
		}
		i = 0;      /* Check for the first command */
		if (isalnum(TextPtr[0])) {  /* Comment? */
			do {
				if (!strcmp(TextPtr,Commands[i])) { /* Match? */
					switch (i) {        /* Execute the command */
					case 0:
//						SetType();   /* Target machine */
						break;
					case 1:
						RestoreSprite(0); 
						break;
					}
					break;      /* Don't parse anymore! */
				}
			} while (++i<CommandCount); /* Keep checking */
		}
		if (i==CommandCount) {      /* Didn't find it? */
			printf("# Command %s not implemented\n",TextPtr);
		}
	}
}




static void RestoreSprite(Word Config) {
FILE *infile, *outfile;
char *TextPtr;
Count++;
char *FinName, *tmpName, *tmpName2;
Word temp, temp2;
int FileSize, i, Off2Entry, Count;
int start_offset, RealStartOffset, offset;
int Width, Height, PRE0, PRE1, PDAT_length;

int Prefix40 = 0x40;
int Prefix80 = 0x80;

struct {
		Word CCB;
		Word Head_50;
		Word Blank;
	} CCB;


struct {
		Word temp;
		Word PLUT;
		Word PLUT_size;
		Word PLUT_value;
	} PLUT;


struct {
		Word temp;
		Word PDAT;
	} PDAT;


		TextPtr = strtok(0,NumDelimiters);
	if (!TextPtr) {
		PrintError("Not enough parms for LOAD");
		return;
	}

	TextPtr = strtok(0,NumDelimiters);
	if (!TextPtr) {
		PrintError("Not enough parms for LOAD");
		return;
	}



//     
infile = fopen(TextPtr, "rb");
cout << "\nFile "<< TextPtr << " opened.";

//    .
fseek(infile,0,SEEK_END);
FileSize = ftell(infile);
rewind(infile);

//   
//    47 E6 42 10.   10 42 - E6 47
Count = 0;
for (i=0; i<FileSize/4; i++) {
			fread(&PDAT.temp,4,1,infile);
			temp = PDAT.temp;
				if (temp == 0x1042E647) {
					Count++;
					}
	}
cout << "\nFrames Count = "<< Count;
rewind(infile);

//       .
char begin[30] = "Recover_";
//tmpName = strcat(begin, TextPtr);
FinName = strcat(begin, TextPtr);
//FinName = strcat(tmpName, itoa(Count, tmpName2, 10));
cout << "\nNew filename = "<< FinName;


//       
outfile = fopen(FinName, "wb");

//   CCB .
CCB.CCB = 0x43434220;
temp = Swap4Bytes(CCB.CCB);
fwrite(&CCB.CCB, 4, 1, outfile);

CCB.Head_50 = 0x000050;
temp = Swap4Bytes(CCB.Head_50);
fwrite(&CCB.Head_50, 4, 1, outfile);

CCB.Blank = 0;
temp = Swap4Bytes(CCB.Blank);
fwrite(&CCB.Blank, 4, 1, outfile);

//     CCB

fseek(infile,0,SEEK_END);
FileSize = ftell(infile);
rewind(infile);


//    .
//   2    .     -  
//    .

//   =40,        ,   .
//      n-. n=??????????

//    (==0),      .


fread(&start_offset, 2, 1, infile);
fread(&start_offset, 2, 1, infile);
RealStartOffset = Swap2Bytes(start_offset);

for (i=0; i<RealStartOffset/2; i++) {
	fread(&offset, 2, 1, infile);
	temp2 = Swap2Bytes(offset);
}
//       CCB.
Off2Entry = RealStartOffset+temp2;
cout << "\nShape CCB offset= "<< Off2Entry;

//     PLUT.
rewind(infile);
fseek(infile,Off2Entry+4,SEEK_SET); // +4,      4 .
//  4 , ,   PC ,      X,Y.
	

	//      CCB  outfile
	for (i=0; i<60/4; i++) {
			fread(&PLUT.temp,4,1,infile);
			temp = PLUT.temp;
			fwrite(&temp, 4, 1, outfile);
		}

//       ,      90 
	//   .
rewind(infile);
fseek(infile,Off2Entry+56,SEEK_SET);

Height = Width = 0;

fread(&PLUT.temp,4,1,infile);
PRE0 = Swap4Bytes(PLUT.temp);
//GetShapeHeight
Height = ((PRE0 >> 6) & 0x3FF) + 1;
cout << "\nHeight = " << Height;

fread(&PLUT.temp,4,1,infile);
PRE1 = Swap4Bytes(PLUT.temp);
//GetShapeWidth	
Width = (PRE1 & 0x7FF) + 1;
cout << "\nWidth = " << Width;

//  
temp = Swap4Bytes(Width);
fwrite(&Width, 4, 1, outfile);

//  
temp = Swap4Bytes(Height);
fwrite(&Height, 4, 1, outfile);


//   PLUT.        .
//    4C.  .
// :
PLUT.PLUT = 0x504C5554;
temp = Swap4Bytes(PLUT.PLUT);
fwrite(&temp, 4, 1, outfile);

PLUT.PLUT_size = 0x00004C;
temp = Swap4Bytes(PLUT.PLUT_size);
fwrite(&temp, 4, 1, outfile);

PLUT.PLUT_value = 0x000020;
temp = Swap4Bytes(PLUT.PLUT_value);
fwrite(&temp, 4, 1, outfile);

//    PLUT
rewind(infile);
fseek(infile,Off2Entry+64,SEEK_SET);

	for (i=0; i<16; i++) {
			fread(&PLUT.temp,4,1,infile);
			temp = PLUT.temp;
			fwrite(&temp, 4, 1, outfile);
		}

//   PDAT.
PDAT.PDAT = 0x50444154;
temp = Swap4Bytes(PDAT.PDAT);
fwrite(&temp, 4, 1, outfile);

//   PDAT.
PDAT_length = 0;
	for (i=0; i<FileSize/4; i++) {
			fread(&PDAT.temp,4,1,infile);
			temp = PDAT.temp;
			PDAT_length += 4;
				//  PDAT.    47 E6 42 10  10 42 - E6 47
				if (temp == 0x1042E647) {
					//  PDAT .
//					PDAT_length += 4;
					cout << "\nNext CCB flags found";
					cout << "\nPDAT_length= " << PDAT_length;
					temp = Swap4Bytes(PDAT_length);
					fwrite(&temp, 4, 1, outfile);
					temp = Swap4Bytes(PDAT_length);
						//    PDAT   .
						rewind(infile);
						fseek(infile,Off2Entry+64+64,SEEK_SET); // 64 -   
						//  64 -  PLUT      (4C)
						cout << "\nOFFSET to PDAT = " << Off2Entry+64+64;
							for (i=0; i<PDAT_length/4-2; i++) { // -2,    PDAT       
									fread(&PDAT.temp,4,1,infile);
									temp = PDAT.temp;
									fwrite(&temp, 4, 1, outfile);
								}
////  ,       ! ////////////

					break;
			}
	}

fclose(outfile);

fclose(infile);
cout << "\nFile "<< TextPtr << " closed.\n";


}





int _tmain(int argc, _TCHAR* argv[])
{
FILE *fp;

Count = 0;

fp = fopen("SpriteList.txt","r");    /* Read the ASCII script */
	if (!fp) {
		printf("# Can't open Textures script file %s.\n",argv[1]);    /* Oh oh */
		return 1;
	}

LoadSprites(fp);

fclose(fp);     /* Close the file */

	cout << "\nPress the enter key to continue ...";
    cin.get();

	return 0;
}

